{ This is a comment. I love commentz. :) }

{$M $800,0,0}
(* Why's so much space for stack? I don't know. Do u? *)
{$A+,B-,D-,E+,F+,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
(* Too much flagz, isn't it? *)


uses Crt, Dos; { Stupid, but I need these.. }
type
  String2 = String[2];

const
  HereIAm: Word = $DEED;                 { My 'signature' }

var
  KbdIntVec: Procedure;                  { original int9 will be stored here }
  UP: Boolean;                           { True if I'm active }
  SaveBuf: array[1..160] Of Byte;        { Space to save original screen line }
  X,Y: Byte;                             { FAT cursor coordinatez }
  BX,BY: Byte;                           { Relative '0' coordinatez }
  SL,Pos: Word;                          { Orig. cursor scanlinez and position }
  Screen1: Byte absolute $b800:$0;       { 0-th videopage 1-st line }
  Screen25: Byte absolute $b800:3840;    { 0-th videopage 25-th line }
  Flagz: Byte absolute $0:$417;          { BIOS KBD flagz live here }
  DeltaX, DeltaY: Byte;                  { Cursor jump [inc|dec]rement }
  BarPos: Byte;                          { Info bar Y position }
  ControlPoint: Word absolute $0:$63*4;  { DOS int63 - pace to sign there }

procedure SatisfyHWR;
{ Makez int controller happy }
begin
  asm
    in   al,  $61
    mov  ah,  al
    or   al,  $80
    out  $61, al
    xchg ah,  al
    out  $61, al
    mov  al,  $20
    out  $20, al     { C00L, isn't it? Taken entirely from TechHelp }
  end;
end;

function LPC(B: Byte): String2;
{ LeftPadChar with "0", e.g. '1' becomez '01' }
var
  S: String2;
begin
  Str(B, S);
  if S[0] = #1 then
    S := '0'+S;
  LPC := S;
end;

procedure UpDate(B: Byte);
{ Updatez info BAR }
var
  SX1, SY1, SX2, SY2: String2;
begin
  if B <> 0 then
    SatisfyHWR;
  case B of { Keyz pressed }
    75: begin if X > DeltaX then Dec(X, DeltaX) else if X = 1 then X := 80 else X := 1; end;
        {left}
    77: begin if X < 81-DeltaX then Inc(X, DeltaX) else if X = 80 then X := 1 else X := 80; end;
        {right}
    72: begin if Y > DeltaY then Dec(Y, DeltaY) else if Y = 1 then Y := 25 else Y := 1; end;
        {up}
    80: begin if Y < 26-DeltaY then Inc(Y, DeltaY) else if Y = 25 then Y := 1 else Y := 25; end;
        {down}
    71: if DeltaX <> 1 then begin X := BX; Y := BY; end else X := 1;
        {home}
    79: begin X := 80; if DeltaX <> 1 then Y := 25; end;
        {end}
    73: begin Y := 1; if DeltaX <> 1 then X := 1; end;
        {pgup}
    81: begin Y := 25; if DeltaX <> 1 then X := 80; end;
        {pgdn}
    59: begin BX := X; BY := Y; end;
        {f1}
    60: begin BX := 1; BY := 1; end;
        {f2}
  end;
  if ((B in [71,72,73,80,81]) and (Y = BarPos)) then
  { If we tryin' to place cursor on info BAR, change BAR position }
  begin
    case BarPos of
      1: begin
           Move(SaveBuf, Screen1, SizeOf(SaveBuf));  { restore line 1 }
           Move(Screen25, SaveBuf, SizeOf(SaveBuf)); { and save line 25 }
         end;
      25: begin
            Move(SaveBuf, Screen25, SizeOf(SaveBuf)); { ...and vice versa }
            Move(Screen1, SaveBuf, SizeOf(SaveBuf));
          end;
    end;
    if BarPos = 1 then
      BarPos := 25
    else
      BarPos := 1;  { switch BAR position }
  end;
  GoToXY(2,BarPos); { draw BAR }
  SX1 := LPC(X-BX);
  SY1 := LPC(Y-BY);
  SX2 := LPC(BX-1);
  SY2 := LPC(BY-1);
  Write(' BASE X:'+SX2+' Y:'+SY2+'  '+
        'Pos: [X:'+SX1+' Y:'+SY1+']'+
        '  F1: BASE to: [X:'+SX1+' Y:'+SY1+'],  F2: BASE to 0:0 ');
  GoToXY(X,Y); { place cursor on it's position }
end;

procedure DoItUp;
{ PopUp everythin' }
begin
  SatisfyHWR;
  UP := True; { We're awaken }
  if BarPos = 1 then
    Move(Screen1, SaveBuf, SizeOf(SaveBuf))
  else
    Move(Screen25, SaveBuf, SizeOf(SaveBuf)); { choose where to draw BAR }
  TextColor($b);
  TextBackground(1); { set fancy colorz }
  asm
    mov ah,3
    int $10
    mov SL,cx { save original cursor scan linez }

    mov ah,1
    mov cx,$001F
    int $10 { make BLOCK cursor }
  end;
  Pos := (WhereY shl 8) + WhereX; { save original cursor position }
  UpDate(0); { draw BAR }
end;

procedure DoItDown;
{ shutdown everythin' }
begin
  if BarPos = 1 then
    Move(SaveBuf, Screen1, SizeOf(SaveBuf))
  else
    Move(SaveBuf, Screen25, SizeOf(SaveBuf)); { restore screen }
  asm
    mov ah,1
    mov cx,SL
    int $10
  end; { restore cursor size }
  GotoXY(Lo(Pos), Hi(Pos)); { ... and position }
  UP := False; { We're dead now. Do not disturb. }
end;

procedure Keyclick; interrupt;
{ Our int9 routine }
var
  PortV: Byte;

begin
  PortV := Port[$60]; { Read port 0x60 }
  if PortV < $80 then { If key is PRESSED }
  begin
    if UP then { do this only if we're active }
    begin
      if PortV = 29 then { is shift pressed? }
      begin
        DeltaX := 10; { yes, set up cursor move deltaz }
        DeltaY := 5;
      end;
      if PortV = 1 then { ESC - escape!!! }
      begin
        DoItDown; { vanishing... }
        SatisfyHWR;
      end
      else
        if PortV in [75,77,72,80,71,79,73,81,59,60] then
          UpDate(PortV) { if one of OUR keys pressed }
        else
          SatisfyHWR; { do nothing }
    end
    else { if we're NOT active }
    begin
      inline ($9C);
      KbdIntVec; { just do what original int9 does }
    end;
    if ((not UP) and (PortV <> 1)) then { if Ctrl+LShift pressed }
      if (Flagz and 6) = 6 then
        DoItUp; { Coo-Coo! }
  end
  else { if key is RELEASED }
  begin
    if PortV = 157 then { Shift key released, so set deltaz to "1" }
    begin
      DeltaX := 1;
      DeltaY := 1;
    end;
    inline($9c);
    KbdIntVec; { and make everybody happy. :^) }
  end;
  PortV := 0; { Why? I don't know. }
end;
{$F-}

begin
  WriteLn('XY v2.1 -- A Screen Pointer.');
  WriteLn('CopyCenter (c) 1995, [DEK] SoftWorks (tm). All Rights Reserved.');
  WriteLn('This is tribute to LEO, my wife.');
  WriteLn;
  { Write some C00L bannerz }
  if ControlPoint = HereIAm then { check out our presence }
  begin
    WriteLn('Already installed, use Ctrl-LShift to activate.');
    Halt(0); { Stop, no more loadz! }
  end;
  ControlPoint := HereIAm; { sign that: I'M HERE. }
  WriteLn('Press Ctrl-LShift to activate, ESC to return.');
  { stupid hint... Userz love hintz.. }
  UP := False; { Nope, I won't popup immediately! }
  X := 1; DeltaX := 1;
  Y := 2; DeltaY := 1;
  BX := 1; BY := 1;
  BarPos := 1; { reset variablez }
  GetIntVec($9,@KbdIntVec); { get old int9 }
  SetIntVec($9,Addr(Keyclick)); { ...and set ourz }
  SwapVectors; { Hmmm.. I think that is good idea. Do u? }
  Keep(0); { TSR }
end.

